<span id="version" style="color: grey; float: right">Version 1.0.2</span>

Credit Risk Portfolio Modeling is necessary for risk, regulatory and accounting purposes in banking institutions. Credit Risk is the most prevalent risk in banks, therefore it must be monitored carefully. They also involve large amount of data that are funnelled though complex transformation and modeling phases to obtain final risk figures.

# Regulations (CECL, IFRS9)

In the United States, CECL or Current Expected Credit Losses is a new method used among companies that follow the Generally Acceptable Accounting Principles (GAAP). CECL's objective revolves around estimating allowances for credit losses issued by the Financial Accounting Standards Board (FASB).

The CECL methodology requires companies to have a proactive approach to calculate credit losses and be able to record an impairment or deduction to their revenues as a result of potential losses. Typically, risk managers are involved in creating the models behind CECL calculations, and accountants are involved in the process of calculating and/or approving the final estimated loss value.

IFRS9 stands for International Financial Reporting Standard 9. Similarly to CECL, it requires credit instruments to be fairly valued, which involves computing the Expected Credit Losses (ECL).

# Stress Testing

Stress Testing encapsulate more ad hoc analysis that aim at capturing the bank's credit risks linked to adverse macroeconomic shocks. These analysis could be carried out at a discretionary level by the bank to improve their reliability or be ordered by a regulatory body such as the Central Bank. They might include more complex hypothesis to take into account future additions to the existing credit portfolios.

# Modeling

Typically three types of models are needed to run this analysis, they will be explained in more detail in their dedicated articles:

- [Probability of Default (PD)](article:4): The likelihood of a loan defaulting.
- [Loss Given Default (LGD)](article:5): When the default happens, which share of the remaining capital is lost and cannot be recovered.
- [Exposure At Default (EAD)](article:6): The remaining balance at some point in the future, when the loan might default.

In the end, ECL is computed as:

```math
ECL = EAD \times PD \times LGD
```

# Data

The mortgage data comes from Freddie Mac, the link to the data documentation is available in the [resources](article:9). We need the historical performance of the loans to understand how they were affected by economic conditions.

Economic Data both for history and forecast come from The Federal Reserve, the reference is in linked in the [resources](article:9).

Housing Price Indices by State come from the [Federal Housing Finance Agency](https://www.fhfa.gov/DataTools/Downloads/Pages/House-Price-Index-Datasets.aspx).

This exhaustive historical data is needed to build the models. However, when running the ECL computation, historical data is no longer needed, the models are applied to the most recent snapshot agains the economic scenarios.